--[[This is a simple Tic Tac Toe game
the graphics are made by chrisk
and the game was coded by cools -> German D!S]]--

--Colors
white = Color.new(255,255,255)
black = Color.new(0,0,0)

--Images
background = Image.load("ms0:/PSP/GAME/PSPMulti/TicTacToe/background.png")
x = Image.load("ms0:/PSP/GAME/PSPMulti/TicTacToe/x.png")
o = Image.load("ms0:/PSP/GAME/PSPMulti/TicTacToe/o.png")
box = Image.load("ms0:/PSP/GAME/PSPMulti/TicTacToe/box.png")

--Squares
dofile("ms0:/PSP/GAME/PSPMulti/TicTacToe/squares.lua")

selected = 1
turnNum = 1
-- - - - - - - - - - - - - - - - - - - - - -
--Box Select Function
function boxselect()
	if analogY < -32 and analogX < -40 then
		screen:blit(95,37,box)
		selected = 1
	end
	
	if analogY < -32 and analogX < 40 and analogX >-40 then
		screen:blit(172,37,box)
		selected = 2
	end

	if analogY < -32 and analogX > 40 then
		screen:blit(249,37,box)
		selected = 3
	end
	
	if analogX < -32 and analogY > -40 and analogY < 40 then
		screen:blit(95,107,box)
		selected = 4
	end
	
	if analogY > -32 and analogY <32 and analogX < 32 and analogX > -32 then
		screen:blit(172,107,box)
		selected = 5
	end
	
	if analogX > 32 and analogY > -40 and analogY < 40 then
		screen:blit(249,107,box)
		selected = 6
	end
	
	if analogY > 32 and analogX < -40 then
		screen:blit(95,177,box)
		selected = 7
	end
	
	if analogY > 32 and analogX < 40 and analogX > -40 then
		screen:blit(172,177,box)
		selected = 8
	end
	
	if analogY > 32 and analogX > 40 then
		screen:blit(249,177,box)
		selected = 9
	end
end
-- - - - - - - - - - - - - - - - - - - - - -
--If even number
function even(num)
	if math.mod(num, 2) == 0 then
		return true
		else return false
	end
end
-- - - - - - - - - - - - - - - - - - - - - -
--Declares who wins the game
function win()
	if sq[1] == 1 and sq[2] == 1 and sq[3] == 1 then return 1 end
	if sq[4] == 1 and sq[5] == 1 and sq[6] == 1 then return 1 end
	if sq[7] == 1 and sq[8] == 1 and sq[9] == 1 then return 1 end
	if sq[1] == 1 and sq[4] == 1 and sq[7] == 1 then return 1 end
	if sq[2] == 1 and sq[5] == 1 and sq[8] == 1 then return 1 end
	if sq[3] == 1 and sq[6] == 1 and sq[9] == 1 then return 1 end
	if sq[1] == 1 and sq[5] == 1 and sq[9] == 1 then return 1 end
	if sq[3] == 1 and sq[5] == 1 and sq[7] == 1 then return 1 end
	if sq[1] == 2 and sq[2] == 2 and sq[3] == 2 then return 2 end
	if sq[4] == 2 and sq[5] == 2 and sq[6] == 2 then return 2 end
	if sq[7] == 2 and sq[8] == 2 and sq[9] == 2 then return 2 end
	if sq[1] == 2 and sq[4] == 2 and sq[7] == 2 then return 2 end
	if sq[2] == 2 and sq[5] == 2 and sq[8] == 2 then return 2 end
	if sq[3] == 2 and sq[6] == 2 and sq[9] == 2 then return 2 end
	if sq[1] == 2 and sq[5] == 2 and sq[9] == 2 then return 2 end
	if sq[3] == 2 and sq[5] == 2 and sq[7] == 2 then return 2 end
end
-- - - - - - - - - - - - - - - - - - - - - -
while true do

pad = Controls.read()
analogX = pad:analogX()
analogY = pad:analogY()
screen:blit(0,0,background)

boxselect()

if even(turnNum) == false then
screen:print(330,80,"Player 1 turn",white)
	for i = 1, 9 do
		if selected == i then
			if sq[i] == 0 then
				if pad:cross() then
					sq[i] = 1
					turnNum = turnNum + 1
				end
			end
		end
	end
end
if even(turnNum) == true then
screen:print(330,80,"Player 2 turn",white)
	for y = 1, 9 do
		if selected == y then
			if sq[y] == 0 then
				if pad:circle() then
					sq[y] = 2
					turnNum = turnNum + 1
				end
			end
		end
	end
end

for r = 1, 3 do
if sq[r] == 1 then screen:blit(110+(r-1)*77,53,x) end
if sq[r] == 2 then screen:blit(110+(r-1)*77,53,o) end
end

for u = 4, 6 do
if sq[u] == 1 then screen:blit(110+(u-4)*77,123,x) end
if sq[u] == 2 then screen:blit(110+(u-4)*77,123,o) end
end

for q = 7, 9 do
if sq[q] == 1 then screen:blit(110+(q-7)*77,193,x) end
if sq[q] == 2 then screen:blit(110+(q-7)*77,193,o) end
end

screen:print(322,90,"Turn Number:" ..turnNum-1,white)

if win() == 1 then
	screen:print(335,100,"Player 1 wins!",white)
	screen:print(345,120,"Play again?",white)
	screen:print(337,130,"Triangle: Yes",white)
	screen:print(350,140,"Square: No",white)
	if pad:triangle() then dofile("ms0:/PSP/GAME/PSPMulti/TicTacToe/squares.lua") selected = 1 turnNum = 1 end
	if pad:square() then break end
end
if win() == 2 then
	screen:print(335,100,"Player 2 wins!",white)
	screen:print(345,120,"Play again?",white)
	screen:print(337,130,"Triangle: Yes",white)
	screen:print(350,140,"Square: No",white)
	if pad:triangle() then dofile("squares.lua") selected = 1 turnNum = 1 end
	if pad:square() then break end
end
if turnNum == 10 and win() ~=1 and win() ~=2 then
	screen:print(375,100,"Remis!",white)
	screen:print(345,120,"Play again?",white)
	screen:print(337,130,"Triangle: Yes",white)
	screen:print(350,140,"Square: No",white)
	if pad:triangle() then dofile("squares.lua") selected = 1 turnNum = 1 end
	if pad:square() then break end
end

if pad:select() then screen:save("screenshot.png") end
if pad:start() then break end
screen.waitVblankStart()
screen.flip()
end