--PSPTunnel v1.0
--by N0ePDA_PSP

colour = Color.new(255,255,255)
blackcol = Color.new(0,0,0)
c = Color.new(255,0,0)
pxlfont = Font.load("ms0:/PSP/GAME/PSPMulti/PSPTunnel/victorpixel.ttf")
pxlfont:setPixelSizes(0, 20)
file = io.open("ms0:/PSP/GAME/PSPMulti/PSPTunnel/High.sco", "r") 
highscore = file:read("*n") 
file:close()
main = Image.load("ms0:/PSP/GAME/PSPMulti/PSPTunnel/main.png")
fig = Image.load("ms0:/PSP/GAME/PSPMulti/PSPTunnel/player.png")
playervar = {x = (240 - fig:width()), y = (270 - fig:height())}
lines = {}
counter = 1
y = 0
first = true
mytimer = Timer.new()
version = "1.0"
time = 0
hard = 80
refre = 25
added = 0
lvl = 1
points = 0
ingame = false

function build()
	if first == true then
		while counter < 69 do
			variety = math.random(-5,5)
			if counter > 39 or counter == 1 then
				left = 240 - (hard / 2)
			else
				left = lines[counter - 1].left + variety
			end
			right = 480 - (hard + left)
			lines[counter] = {y = y, xleft = 0, xright = left + hard, left = left, right = right}
			screen:fillRect(lines[counter].xleft, lines[counter].y, left, 4, colour)
			screen:fillRect(lines[counter].xright, lines[counter].y, right, 4, colour)
			counter = counter + 1
			y = y + 4
			mytimer:start()
		end
	first = false
	end
	
	if first == false then
		counter = 1
		while counter < 69 do
			screen:fillRect(lines[counter].xleft, lines[counter].y, lines[counter].left, 4, colour)
			screen:fillRect(lines[counter].xright, lines[counter].y, lines[counter].right, 4, colour)
			counter = counter + 1
		end
	
	end
		
end

function crash()
	if points > highscore then
		screen:fontPrint(pxlfont, 1,47, "New Highscore!", blackcol)
		screen.flip()
		highscore = points
		file = io.open("ms0:/PSP/GAME/PSPMulti/PSPTunnel/high.sco","w")
		file:write(highscore)
		file:close()
		mytimer:reset(0)
		System.sleep(2000)
	end
	ingame = false		
end

function check()
	counter = 50
	while counter < 69 do
		if lines[counter].left >= playervar.x and lines[counter].y >= playervar.y then
			crash()
		elseif lines[counter].xright <= (playervar.x + fig:width()) and lines[counter].y >= playervar.y then
			crash()
		end
		counter = counter + 1
	end
end

while true do
	if ingame == true then
	screen:clear()
	pad = Controls.read()
	build()
	
	if pad:left() then
		if playervar.x > 1 then
			playervar.x = playervar.x - 1
		end
	end
	
	if pad:right() then
		if playervar.x < 479 then
			playervar.x = playervar.x + 1
		end
	end
	
	if pad:analogX()> 25 then
		if playervar.x > 1 then
			playervar.x = playervar.x + 1
		end
	elseif pad:analogX()< -25 then
		if playervar.x < 479 then
			playervar.x = playervar.x - 1
		end
	end
	
	check()
	countertime = mytimer:time()
	if countertime >= refre then
		time = time + 1
		tempint = 1
		linecopy = {}
		while tempint < 69 do
			linecopy[tempint] = lines[tempint]
			tempint = tempint + 1
		end
		tempint = 1
		while tempint < 69 do
			lines[(tempint + 1)] = linecopy[tempint]
			tempint = tempint + 1
		end
		tempint = 2
		while tempint < 69 do
			lines[tempint].y = lines[tempint].y + 4
			tempint = tempint + 1
		end
		tempint = 1
		variety = math.random(-5,5)
		left = lines[tempint].left + variety
		right = 480 - (hard + left)
		lines[tempint] = {y = 0, xleft = 0, xright = left + hard, left = left, right = right}
		added = added + 1
		points = points + 1
		
		if added >= 250 then
			added = 0
			if lvl < 13 then
				lvl = lvl + 1
				hard = hard - 2
			elseif refre > 0 then
				lvl = lvl + 1
				refre = refre - 5
			end
		end
		
		mytimer:reset(0)
		mytimer:start()
	end
	screen:blit(playervar.x, playervar.y, fig, true)
	screen:fontPrint(pxlfont, 1,13, "Score:", blackcol)
	screen:fontPrint(pxlfont, 1,30, points, blackcol)
	screen.waitVblankStart()
	screen.flip()
	
	else
	screen:blit(0,0,main)
	screen:fontPrint(pxlfont, 152,220, highscore, colour)
	screen:print(1,263,"v" .. version .. ", by N0ePDA_PSP",colour)
	pad = Controls.read()
	if pad:cross() or pad:start() then
		playervar = {x = (240 - fig:width()), y = (270 - fig:height())}
		lines = {}
		counter = 1
		y = 0
		first = true
		mytimer = Timer.new()
		time = 0
		hard = 80
		refre = 25
		added = 0
		lvl = 1
		points = 0
		ingame = true
	end
	if pad:start() then
dofile("SCRIPT1.lua")
end	
	screen.flip()
	end
end